import AnimeMainInformation from './lib/interfaces/anime/MainInformation';
import AnimeCharactersAndStaff from './lib/interfaces/anime/CharactersAndStaff';
import MangaMainInformation from './lib/interfaces/manga/MainInformation';
import MangaCharacters from './lib/interfaces/manga/Characters';
import GenreAnimeByGenre from './lib/interfaces/genre/AnimeByGenre';
import GenreMangaByGenre from './lib/interfaces/genre/MangaByGenre';

declare module 'jikan-nodejs' {
  export function itemById(
    type: string,
    mal_id: number,
  ): AnimeMainInformation | MangaMainInformation;

  namespace anime {
    export function mainInformation(): AnimeMainInformation;
    export function charactersAndStaff(): AnimeCharactersAndStaff;
  }

  namespace manga {
    export function mainInformation(): MangaMainInformation;
    export function characters(): MangaCharacters;
  }

  namespace genre {
    export function animeByGenre(): GenreAnimeByGenre;
    export function mangaByGenre(): GenreMangaByGenre;
  }
}
